(function () {
    'use strict';

    angular
        .module('myapp.hellowidget')
        .controller('hellowidgetController', hellowidgetController);

    /* @ngInject */
    function hellowidgetController(
        $scope,
        $q,
        c8yInventory,
        c8yBinary,
        c8yMeasurements
    ) {

        function init() {
            console.log("init");

            // リアルタイム監視用のフィルタ設定
            var filter = {
                device: $scope.child.config.device.id,
                fragment: "c8y_Temperature",
                series: "T"
            };

            // latestMeasurementという値でデータバインディングする
            var realtime = true;
            c8yMeasurements.latest(filter, realtime)
                .then(function (measurement) {
                    // measurement に最新のセンサーデータがJSON構造で出力されている
                    $scope.currentValue = function(){
                        return measurement[filter.fragment][filter.series].value;  // センサー値
                    };
                    $scope.currentUnit = function(){
                        return measurement[filter.fragment][filter.series].unit;  // センサー単位
                    };
                });
        }

        // デバイス選択UIでの変更の監視
        $scope.$watch('child.config.device', function (newVal, oldVal) {
            if(newVal && !_.isEqual(newVal, oldVal)) {
                // デバイス対象が更新されるたびに初期化する
                init();
            }
        }, true);

        // 値変更の監視
        $scope.$watch('child.config.helloMessage', function (newVal, oldVal) {
            if(newVal && !_.isEqual(newVal, oldVal)) {
                console.log("DataChange");
                init();
            }
        }, true);

        // ウィジェット破棄イベント
        function onDestroy() {
            console.log( 'onDestroy');
        }

        // 初期化
        init();
        // ウィジェット破棄イベント関連付け
        $scope.$on('$destroy', onDestroy);
    }
}());